const connectOnDemandAndCall = async (pool, method, ...args) => {
  if (pool.disposed) {
    throw new Error('Adapter has been already disposed');
  }

  pool.isConnected = true;
  const connectPromise = pool.getConnectPromise();
  await connectPromise;
  return await method(pool, ...args);
};

function generateAssertTrap() {
  return (...args) => {
    throw new Error('Adapter method is not implemented');
  };
}

const wrapMethod = (pool, method) => {
  if (method === undefined) return generateAssertTrap();else return async (...args) => {
    return await connectOnDemandAndCall(pool, method, ...args);
  };
};

export default wrapMethod;
//# sourceMappingURL=wrap-method.js.map